## Browsing a repository

If you visit the repository page, it looks like below:

![A typical repository page](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/repository-top.png)

From here, you can browse what is in the repository including:

1. [overview of the repository](#overview-of-the-repository)
2. [file contents](#browsing-files)

### Overview of the repository

On top of the page, you will find the header consisting of `<owner name>/<repository name>`:

![Repository name](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/repository-title.png)

This represents the _identifier_ of the repository so that 
you can specify a single repository inside `https://gin.g-node.org`.

Down to the bottom, you may find some document:

![README file](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/readme.png)

This represents the (hopefully) detailed description of the repository about what it is
or what it contains.

> In fact, this description comes from the `README.md` file in the root directory of the repository.
> The name of the file comes from a tradition of programmers community to contain the "read-me-first"
> file in the top directory of any code.
>
> You can add or edit it by adding / editing the `README.md` file.
> 
> Even inside the sub-directories of the repositories, the description will automatically show up
> if you add and edit a `README.md` file in it.

### Browsing files

In the middle, you can find a list of files and directories in the repository:

![File list](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/files.png)

By clicking on individual file/directory entry, you can browse its contents.

For example, you can see the contents of a sub-directory by clicking on it:

![Directory view](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/directory-view.png)

Contents of normal files may be visible, as long as your browser supports it.

- For example, you can browse to [web-interface/images/dashboard.png](images/dashboard.png),
and you can have a glimpse of the original image file:
  ![Image-file view](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/image-view.png)

- If you write the documents in the [Markdown](https://www.markdownguide.org/getting-started) format
  (and I recommend to do so whenever possible), you can see the formatted-view of the document:
  ![Markdown view](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/markdown-view.png)

- Other text-based files (CSV, TSV etc.) may be seen in its raw format.
- Binary files (Excel, Word, Spike2 etc.) will not be visible, so you must [download it](downloading.md) to see the contents.

#### A small side note

On the left columns of the files list, you can see some information like below:

![Commit description](https://gin.g-node.org/larkumlab/Dealing_with_Gin/raw/book/web-interface/images/commit-description.png)

Sadly **it is _not_ about the description to the file itself** but describes the commit
that updated this file most recently.

In the case of the image above, the directory "web-interface" was updated by the commit
with the commit ID being `b42b7633f7`, and with the commit message `update dashboard.md`.